//******************************************************************************
//
// 	(C) 1993,94 by Radicon Ltd.
// 	Define variable
// 	11-18-92 12:55pm
//******************************************************************************
#include    "dos.h"
#include    "windows.h"
#include 		"dfkisl.h"
#include 		"prkmpt1.h"

#define HD

#ifdef HD
extern LPSTR			pTime;
#else
extern unsigned char	 	bufmsg[];
#endif

/************************************************
 *          --- int tr_message ---
 *  transmit message to controller
 * returns code:
 * 0    - o'key
 * -1   - error
 * -2   - controller can't make this function to
 * present time or error code function
 * -3   - check summ error
 ************************************************/
#ifdef DEBUG
int retspot_tr;
#endif //def DEBUG

int tr_message(fun,rd,rs,p,l)
int fun,  /* function code */
		rd,   /* data register */
		rs;   /* state register */
unsigned char *p;  /* data buffer */
int l;    /* number of transmitting bytes */
{
register int i,j,k;
int w;
// unsigned char *p = bufmsg;
#ifndef __WIN32__
	_asm {
		mov dx,rd     ;
		in  al,dx     ;
	}
#endif
/*  inp(rd);  */

	i=out_byte(rd,rs,fun); /* transmit function code */
	if (i == -1)
		{
#ifdef DEBUG
			retspot_tr = 1;
#endif //def DEBUG
			return -1;
		}

	i=in_byte(rd,rs,&w);
	if (i == -1)
		{
#ifdef DEBUG
			retspot_tr = 2;
#endif //def DEBUG
			return -1;
		}

	if (w != ACK) {
		if (fun == CFF && w == PROGR)
			{
#ifdef DEBUG
				retspot_tr = 0;
#endif //def DEBUG
				return 0;
			}
		if (w == NAK)
			{
#ifdef DEBUG
				retspot_tr = 3;
#endif //def DEBUG
				return -2;
			}
#ifdef DEBUG
		retspot_tr = 4;
#endif //def DEBUG
		return -1;
	}

	k=0;

	for (i=0; i < l; i++)
		{
		j=out_byte(rd,rs,*p);
		if(j == -1)
			{
#ifdef DEBUG
				retspot_tr = 5;
#endif //def DEBUG
				return -1;
			}
		k=k + *p;
		if (*p == 0x10)
			{
			j=out_byte(rd,rs,*p);
			if (j == -1)
				{
#ifdef DEBUG
					retspot_tr = 6;
#endif //def DEBUG
					return -1;
				}
			k=k + *p;
		}
		p++;
	}

	j=out_byte(rd,rs,DLE);
	if (j == -1)
		{
#ifdef DEBUG
			retspot_tr = 7;
#endif //def DEBUG
			return -1;
		}
	k=k + DLE;

	j=out_byte(rd,rs,EOT);
	if (j == -1)
		{
#ifdef DEBUG
			retspot_tr = 8;
#endif //def DEBUG
			return -1;
		}
	k=k + EOT;

	k=~k;
	k++;

	j=out_byte(rd,rs,k);
	if (j == -1)
		{
#ifdef DEBUG
			retspot_tr = 9;
#endif //def DEBUG
			return -1;
		}

	i=in_byte(rd,rs,&w);
	if (i == -1)
		{
#ifdef DEBUG
			retspot_tr = 10;
#endif //def DEBUG
			return -1;
		}

	if (w == NAK)
		{
#ifdef DEBUG
			retspot_tr = 11;
#endif //def DEBUG
			return -3;
		}

#ifdef DEBUG
	retspot_tr = 0;
#endif //def DEBUG
	return 0;

}


/************************************************
 *          --- int rc_message ---
 *  receive message from controller
 * returns code:
 * 0    - o'key
 * -1   - error
 * -2   - controller can't make this function to
 * present time or error code function.
 * -3   - check summ error
 * -4   - data isn't ready
 ************************************************/
#ifdef DEBUG
int retspot_rc;
#endif //def DEBUG

int rc_message(fun,rd,rs,p,ml,l)
int fun,  /* function code */
		rd,   /* data register */
		rs;   /* state register */
unsigned char *p;  /* data buffer */
int ml;   /* max length of received data */
int *l;   /* number of received bytes */
{
register int i,j;
int w1,w2;
#ifndef __WIN32__
	_asm {
		mov dx,rd     ;
		in  al,dx     ;
	}
#endif
/*  inp(rd); */

	i=out_byte(rd,rs,fun);
	if (i == -1)
		{
#ifdef DEBUG
			retspot_rc = 1;
#endif //def DEBUG
			return i;
		}

  i=in_byte(rd,rs,&w1);
  if (i == -1)
    {
#ifdef DEBUG
      retspot_rc = 2;
#endif //def DEBUG
      return i;
    }

  if (w1 != ACK) {
    if (w1 == CAN)
			{
#ifdef DEBUG
				retspot_rc = 3;
#endif //def DEBUG
        return -4;
      }
		if (w1 == NAK)
      {
#ifdef DEBUG
        retspot_rc = 4;
#endif //def DEBUG
        return -2;
			}
#ifdef DEBUG
    retspot_rc = 5;
#endif //def DEBUG
    return -1;
  }

  j=0;
  *l = 0;

  while ((*l) < ml) {
    i=in_byte(rd,rs,&w1);
    if (i == -1)
      {
#ifdef DEBUG
        retspot_rc = 6;
#endif //def DEBUG
        return -1;
      }

    j=j+w1;

    if (w1 == DLE) {
      i=in_byte(rd,rs,&w2);
      if (i == -1)
				{
#ifdef DEBUG
          retspot_rc = 7;
#endif //def DEBUG
          return -1;
        }

      j=j+w2;

			if (w2 == EOT)
          break;
      if (w2 != DLE)
        {
#ifdef DEBUG
          retspot_rc = 8;
#endif //def DEBUG
          return -1;
        }
    }
		*p=w1;
    p++;
    (*l)++;
  }

  i=in_byte(rd,rs,&w1);
	if (i == -1)
    {
#ifdef DEBUG
      retspot_rc = 9; 
#endif //def DEBUG
      return -1;
    }
  j=(j+w1) & 0xff;

  if (j != 0) {
    i=out_byte(rd,rs,NAK);
    if (i == -1)
      {
#ifdef DEBUG
        retspot_rc = 10; 
#endif //def DEBUG
        return -1;
      }
#ifdef DEBUG
		retspot_rc = 11;
#endif //def DEBUG
    return -3;
  }

  i=out_byte(rd,rs,ACK);
	if (i == -1)
    {
#ifdef DEBUG
      retspot_rc = 12; 
#endif //def DEBUG
      return -1;
		}
#ifdef DEBUG
	retspot_rc = 0;
#endif //def DEBUG
  return 0;

}


/************************************************
 *           --- int out_byte ---
 *  transmit byte
 * return code:
 * 0    o'key
 * -1   error
 ************************************************/
#ifdef DEBUG
int retspot_out;
#endif //def DEBUG

int out_byte(rd,rs,d)
int rd, /* data register */
    rs, /* state registers */
    d;  /* data */
{
register int i,j,k;

	i=j=crnt_time();

	while (j-i < TMOUT) {
		k=status_wr(rs);
		if (k == 0) break;
		j=crnt_time();
		if (j < i) i=j;
	}

	if (k != 0)
		{
#ifdef DEBUG
			retspot_out = 1;
#endif //def DEBUG
      return -1;
    }
#ifndef __WIN32__
	_asm {
    mov dx,rd     ;
		mov ax,d      ;
    out dx,al     ;
  }
#endif
/*  outp(rd,d); */

#ifdef DEBUG
  retspot_out = 0;
#endif //def DEBUG
  return 0;

}



/************************************************
 *            --- int in_byte ---
 *  receive byte
 * return code:
 * 0    o'key
 * -1   error
 ************************************************/
#ifdef DEBUG
int retspot_in;
#endif //def DEBUG

int in_byte(rd,rs,d)
int rd, /* data register */
    rs, /* state register */
    *d; /* data */
{
register int i,j,k;


  i=j=crnt_time();

  while (j-i < TMOUT) {
    k=status_rd(rs);
    if (k != 0) break;
    j=crnt_time();
    if (j < i) i=j;
  }

  if (k == 0)
    {
#ifdef DEBUG
      retspot_in = 1;
#endif //def DEBUG
			return -1;
		}
#ifndef __WIN32__
  _asm {
    sub ax,ax
    mov dx,rd
    in  al,dx
    mov i,ax
  }
#endif
  *d=i;

/*  *d=inp(rd);*/

#ifdef DEBUG
  retspot_in = 0;
#endif //def DEBUG
  return 0;

}


/************************************************
 *           --- int status_rd ---
 *  read state input register
 * return code:
 * zero       - input register is empty
 * not zero   - input register isn't empty
 ************************************************/
int status_rd(rs)
int rs; /* register of status */
  {
#ifndef __WIN32__
	_asm {
    mov dx,rs
    in  al,dx
    and ax,MSKREAD
  }
#endif
  return _AX;
}

/************************************************
 *           --- int status_wr ---
 *  read state output register
 * return code:
 * zero       - output register is empty
 * not zero   - output register isn't empty
 ************************************************/
int status_wr(rs)
int rs; /* register of status */
  {
  #ifndef __WIN32__

  _asm {
    mov dx,rs
		in  al,dx
		and ax,MSKWRITE
	}
#endif
	return _AX;
}


/************************************************
 *            --- int crnt_time ---
 *  getting current time (msecond)
 ************************************************/

#ifdef HD
int crnt_time()
	{
	return *pTime;
	}
#else
DWORD crnt_time()
	{
	return timeGetTime()
	}
#endif
// __LastLine__


